%cdma_pulse.m
%generira CDMA zaporedje
clear all
close all

N=8;        %razmerje bit/chip rate
T=512;      %dolina trajanja enega bita
Tc=T/N;     %doina trajanja enega chipa = perioda nosilnega signala!

k=(1:2*T)';
x=(k-1);     % casovna os

%dva bita +1/-1:
yb=(k<=512);    

%serija nakljunih tevil +1/-1
a=(rand(1,2*N)<=0.5);

%razirimo nakljuno generirane bite na dejansko dolino trajanja
yc=reshape(ones(Tc,1)*a,size(ones(Tc,1)*a,1)*size(ones(Tc,1)*a,2),1);

% setevanje po modulu 2
ys=xor(yb,yc);

%izris 3 bitnih nizov
figure
subplot(3,1,1);
plot(x,yb,'k'), title('zaporedje bitov')
axis off
subplot(3,1,2);
plot(x,yc,'k'), title('zaporedje chipov')
axis off
subplot(3,1,3);
plot(x,ys,'k'),title('modulo 2 vsota bitnega niza in chipov')
axis off

%BPSK-DSSS modulacija (bit vrti fazo za pi)
ym=(2*ys-1).*cos(2*pi*(1/Tc)*x);
figure
plot(x,ym,'.')
ylim([-2 2])
ylabel('BPSK-DSSS signal')
xlabel('zap. st. vzorca')
xlim([0 1023])

%izris spektrov bita in chipa: uporabimo po 1 impulz!
figure
yb_1=(x<=511);
yc_1=(x<=63);
plot(x,abs(fft(yb_1,1024))/max(abs(fft(yb_1,1024))),'r',x,abs(fft(yc_1,1024))/max(abs(fft(yc_1,1024))),'k');
xlim([0 64])
xlabel('zap. st. vzorca')
ylabel('Normalizirani spekter')
legend('bitno zaporedje','zaporedje chipov')